mod Ex09 logic: 'cl'

incl Mtex

incl Mtexg

incl Maux

loc rem 
  \para \bf  9. CVICENIE Z PREDMETU M-INAA-046 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end stvrtok 26.4.2007 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INAA-046-svp/0607ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnym stromom. 
  Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Trees.  \end 

rem 
  \para \bf  Arithmetization of labelled binary trees.  \end 

fun/0 E 'Tex_f0_bt_e'
  E = 0,0

fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

rem 
  \para \bf  Structural case analysis on binary trees.  \end Show that the 
  principle of structural case analysis over binary trees is admissible in Peano 
  arithmetic. 
  \para \it  Remark.  \end Prove the following claim justifying the completeness 
  condition of the principle: 
  \eq* 
    Bt(t) -> t = E \/ \e x\e l\e r(t = Nd(x,l,r) & Bt(l) & Bt(r))
  \end
  \para \it  Hint.  \end By pair case analysis. 

thm Case_analysis_on_binary_trees
  Bt(t) -> t = E \/ \e x\e l\e r(t = Nd(x,l,r) & Bt(l) & Bt(r))

rem 
  \para \bf  [CL] Structural case analysis on binary trees.  \end Syntax: 
  \eq* 
    'case Bt ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(Bt,t) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_assum Bt(t),
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(t,E),
                                              Tex_f1_g_x_assum Tex_f2_g_and(Tex_f2_g_eq(t,
                                                                                        Nd(x,
                                                                                           l,
                                                                                           r)),
                                                                            Tex_f2_g_and(Bt(l),
                                                                                         Bt(r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  Structural induction on binary trees.  \end Show that the principle 
  of structural induction over binary_trees is admissible in Peano arithmetic. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 
  \para \it  [CL] Hint.  \end Reduce structural induction on \ft t \end to 
  course of values induction with measure \ft |t| \end. Recall that the pair 
  size function \ft |x| \end, written as \it  |x|  \end, is defined in the 
  module \it  Standard  \end. 

theory Structural_induction_on_binary_trees

pred A 'Tex_p1_phi_subst'

axiom Base_case
  A(E)

axiom Induction_step
  A(l) & A(r) -> A Nd(x,l,r)

thm Conclusion
  Bt(t) -> A(t)

end theory Structural_induction_on_binary_trees

rem 
  \para \bf  [CL] Structural induction on binary trees.  \end Syntax: 
  \eq* 
    'ind Bt ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Bt,t) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Bt(t),
                                                         Tex2_bappl1(Tex0_phi,t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          E),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex2_bappl1(Tex0_phi,
                                                                                                    l),
                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                    r)),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       Nd(x,
                                                                                          l,
                                                                                          r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Tex_f2_g_x_sc(Bt,t),y,z) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Bt(t),
                                                         Tex2_bappl1(Tex0_phi,t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          E),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex_f2_g_forall(y,
                                                                                                        Tex_f2_g_forall(z,
                                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                                    l))),
                                                                                        Tex_f2_g_forall(y,
                                                                                                        Tex_f2_g_forall(z,
                                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                                    r)))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       Nd(x,
                                                                                          l,
                                                                                          r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  [CL] Structural induction on binary trees (2nd form).  \end Syntax: 
  \eq* 
    'ind* Bt ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_inds Tex_f2_g_x_sc(Bt,t) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Bt(t),
                                                         Tex2_bappl1(Tex0_phi,t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          E),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Bt(l),
                                                                                        Tex_f2_g_and(Tex2_bappl1(Tex0_phi,
                                                                                                                 l),
                                                                                                     Tex_f2_g_and(Bt(r),
                                                                                                                  Tex2_bappl1(Tex0_phi,
                                                                                                                              r)))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       Nd(x,
                                                                                          l,
                                                                                          r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
   \item \para \ft Tex_f1_g_x_inds Tex_f2_g_x_sc(Tex_f2_g_x_sc(Bt,t),y,z) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Bt(t),
                                                         Tex2_bappl1(Tex0_phi,t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          E),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Bt(l),
                                                                                        Tex_f2_g_and(Tex_f2_g_forall(y,
                                                                                                                     Tex_f2_g_forall(z,
                                                                                                                                     Tex2_bappl1(Tex0_phi,
                                                                                                                                                 l))),
                                                                                                     Tex_f2_g_and(Bt(r),
                                                                                                                  Tex_f2_g_forall(y,
                                                                                                                                  Tex_f2_g_forall(z,
                                                                                                                                                  Tex2_bappl1(Tex0_phi,
                                                                                                                                                              r)))))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       Nd(x,
                                                                                          l,
                                                                                          r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  Membership in binary trees.  \end 

pred/2 Inbt 'Tex_p2_bt_in'
  Inbt(x,t) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    ~Inbt(x,E)
  \end
  \eq* 
    Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)
  \end

thm Inbt_e
  ~Inbt(x,E)

thm Inbt_nd
  Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)

rem 
  \para \bf  Size and depth of binary trees.  \end 

fun Sz 'Tex_f1_bt_sz'
  Sz(t) = Foo

fun Dp 'Tex_f1_bt_dp'
  Dp(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Sz(t) = 0 <-> t = E
  \end
  \eq* 
    Bt(t) -> Dp(t) = 0 <-> t = E
  \end
  \para \it  Hint.  \end By structural case analysis on the binary tree 
  \ft t \end. 

thm Sz_is_zero
  Bt(t) -> Sz(t) = 0 <-> t = E

thm Dp_is_zero
  Bt(t) -> Dp(t) = 0 <-> t = E

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Dp(t) <= Sz(t) & Sz(t) < Exp(2,Dp(t))
  \end
  \para \it  [CL] Hint.  \end Use the theorem \it  Exp_le  \end from the module 
  \it  Maux  \end. 

thm Dp_sz
  Bt(t) -> Dp(t) <= Sz(t) & Sz(t) < Exp(2,Dp(t))
proof  proved.

rem 
  \para \bf  Reflection function.  \end 

fun Reflect 
  Reflect(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Bt Reflect(t)
  \end
  \eq* 
    Bt(t) -> Inbt(x,Reflect(t)) <-> Inbt(x,t)
  \end
  \eq* 
    Bt(t) -> Sz Reflect(t) = Sz(t)
  \end
  \eq* 
    Bt(t) -> Dp Reflect(t) = Dp(t)
  \end
  \eq* 
    Bt(t) -> Reflect Reflect(t) = t
  \end
  \eq* 
    Bt(t1) & Bt(t2) & Reflect(t1) = Reflect(t2) -> t1 = t2
  \end
  \eq* 
    Bt(t1) -> \e t2 Reflect(t2) = t1
  \end

thm Reflect_bt
  Bt(t) -> Bt Reflect(t)

thm Reflect_inbt
  Bt(t) -> Inbt(x,Reflect(t)) <-> Inbt(x,t)

thm Reflect_sz
  Bt(t) -> Sz Reflect(t) = Sz(t)
proof  proved.

thm Reflect_dp
  Bt(t) -> Dp Reflect(t) = Dp(t)
proof  proved.

thm Reflect_reflect
  Bt(t) -> Reflect Reflect(t) = t

thm Reflect_injective
  Bt(t1) & Bt(t2) & Reflect(t1) = Reflect(t2) -> t1 = t2

thm Reflect_surjective
  Bt(t1) -> \e t2 Reflect(t2) = t1

rem 
  \para \bf  Traversals of binary trees.  \end 

fun Preorder 
  Preorder(t) = Foo

fun Inorder 
  Inorder(t) = Foo

fun Postorder 
  Postorder(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> L Preorder(t) = Sz(t)
  \end
  \eq* 
    Bt(t) -> x in Preorder(t) <-> Inbt(x,t)
  \end
  \eq* 
    Bt(t) -> L Inorder(t) = Sz(t)
  \end
  \eq* 
    Bt(t) -> x in Inorder(t) <-> Inbt(x,t)
  \end
  \eq* 
    Bt(t) -> L Postorder(t) = Sz(t)
  \end
  \eq* 
    Bt(t) -> x in Postorder(t) <-> Inbt(x,t)
  \end

thm Preorder_m
  Bt(t) -> L Preorder(t) = Sz(t)
proof  proved.

thm Preorder_inbt
  Bt(t) -> x in Preorder(t) <-> Inbt(x,t)

thm Inorder_m
  Bt(t) -> L Inorder(t) = Sz(t)
proof  proved.

thm Inorder_inbt
  Bt(t) -> x in Inorder(t) <-> Inbt(x,t)

thm Postorder_m
  Bt(t) -> L Postorder(t) = Sz(t)
proof  proved.

thm Postorder_inbt
  Bt(t) -> x in Postorder(t) <-> Inbt(x,t)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Preorder(t) = Rev Postorder Reflect(t)
  \end
  \eq* 
    Bt(t) -> Postorder(t) = Rev Preorder Reflect(t)
  \end

thm Preorder_postorder
  Bt(t) -> Preorder(t) = Rev Postorder Reflect(t)
proof  proved.

thm Postorder_preorder
  Bt(t) -> Postorder(t) = Rev Preorder Reflect(t)
proof  proved.

rem 
  \para \bf  Fast programs for tree traversals.  \end 

rem 
  \para \bf  Case: preorder traversal.  \end 

fun/2 Preordera 'Tex_f2_f'
  Preordera(E,a) = a
  Preordera(Nd(x,l,r),a) = x,Preordera(l,Preordera(r,a))

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Preorder(t) = Preordera(t,0)
  \end

thm Preorder_by_preordera
  Bt(t) -> Preorder(t) = Preordera(t,0)

rem 
  \para \bf  Case: inorder traversal.  \end 

rem 
  \para \bf  Exercise.  \end Save the concatenation in the definition of the 
  function \ft Inorder(t) \end with help of an accumulator function and verify 
  your implementation. 

rem 
  \para \bf  Case: postorder traversal.  \end 

rem 
  \para \bf  Exercise.  \end Save the concatenation in the definition of the 
  function \ft Postorder(t) \end with help of an accumulator function and verify 
  your implementation. 

